check_dupl=False
if check_dupl:
    print("build a dictionnary with the segment sizes")
    segments_file = open('seg_coord/segments.txt','r')
    lines=segments_file.readlines()
    segments_file.close()
    seg_size={}

    for line in lines:
        line=line.split()
        seg_id='s'+line[1]
        segment_size=len(line[2])
        seg_size[seg_id]=segment_size

    print("nb segments dans le graphe : ",len(seg_size))

    print("read the paths and store the segments in a dict")
    segments = open('../test_all_genomes/seg_coord/walks.txt','r')
    lines=segments.readlines()
    segments.close()
    dict={} # store sthe segments met in the walks
    for line in lines :
        line=line.split()
        name=line[1]+"_"+line[3]
        if ("MINIGRAPH" not in name) and ("IRGSP" not in name): 
            path_start=int(line[4])
            seq_name=line[3]
            dict[seq_name]={}
            path=line[6].split(',')
            for i in range(1, len(path)): # for each segment in the path, write the position of the segment in the output bed file
                seg_name=path[i]
                if seg_name not in dict[seq_name]:
                    dict[seq_name][seg_name]=list()
                    dict[seq_name][seg_name].append(seg_name)
                else:
                    dict[seq_name][seg_name].append(seg_name)

    print("count the duplications")
    list_nb_segments=[]
    nb_seg_conc=0
    seg_total=0
    seg_dupl_len=list()
    all_seg_len=list()
    segments_met={}
    segments_dupl_met={}
    f = open('doublons_segments.txt','w')
    for walk in dict:
        for segment_id in dict[walk]:
            seg_total+=1
            segment_list=dict[walk][segment_id]
            segment='s'+segment_list[0][1:]
            if segment not in segments_met:
                all_seg_len.append(seg_size[segment])
                segments_met[segment]=True
            if len(segment_list)>1:
                line=walk+"\t"+segment+"\n"
                f.write(line)
                if len(segment_list) not in list_nb_segments:
                    list_nb_segments.append(len(segment_list))
                if segment not in segments_dupl_met:
                    seg_dupl_len.append(seg_size[segment])
                    segments_dupl_met[segment]=True
                nb_seg_conc+=1
    from statistics import mean
    print(list_nb_segments,nb_seg_conc,seg_total,mean(seg_dupl_len),mean(all_seg_len)) # list of number of copies found, how many segments are present at least twice in a walk, number of segments total.

    # print("plot the repartitions of the segments length (duplicated segments or all segments)")
    # import seaborn as sns
    # import matplotlib.pyplot as plt
    # import pandas as pd

    # sns.set_theme(style="darkgrid")
    # sns
    # data_dupl = {'seg_len': seg_dupl_len}
    # df_dupl = pd.DataFrame(data_dupl)
    # sns.histplot(data=df_dupl, x="seg_len")
    # plt.show()


    # data too big, crashes the computer ?

    # sns.set_theme(style="darkgrid")
    # sns
    # data_all = {'seg_len': all_seg_len}
    # df_all = pd.DataFrame(data_all)
    # sns.histplot(data=df_all, x="seg_len")
    # plt.show()



compare_gff=False
if compare_gff:
    new = open('Os117425RS1/Os117425RS1.gff','r')
    lines_new=new.readlines()
    new.close()
    dict_genes_new={}
    for line in lines_new:
        line=line.split()
        gene_id=line[8].split(';')[0]
        if gene_id not in dict_genes_new:
            dict_genes_new[gene_id]=[line[0]]
        else:
            dict_genes_new[gene_id].append(line[0])


    old = open('Os117425RS1/Os117425RS1_genes_old.gff','r')
    lines_old=old.readlines()
    old.close()
    dict_genes_old={}
    for line in lines_old:
        line=line.split()
        gene_id=line[8].split(';')[0]
        if gene_id not in dict_genes_old:
            dict_genes_old[gene_id]=[line[0]]
        else:
            dict_genes_old[gene_id].append(line[0])

    for gene in dict_genes_new:
        if gene in dict_genes_old:
            if len(dict_genes_new[gene])!=len(dict_genes_old[gene]):
                print("len diff : new,old,gene_id :",len(dict_genes_new[gene]),len(dict_genes_old[gene]),gene)
        else:
            print("gene from new missing from old ",gene)
    print("\n")
    for gene in dict_genes_old:
        if gene not in dict_genes_new:
            print("gene from new missing from new ",gene)

    print("len of both dict: ",len(dict_genes_new),len(dict_genes_old))


stat_var_by_feature=False
if stat_var_by_feature:
    var_file = open('Azucena_var.txt','r')
    lines_var=var_file.readlines()
    var_file.close()
    dict_var={} # feature_id -> [type,length,ins_count,del_count_subs_count]
    
    for line in lines_var:
        var=line.split()
        feature_id=var[0]

        if feature_id not in dict_var:
            feature_type=var[1]
            feature_size_new=int(var[5])
            feature_size_diff=int(var[7])
            feature_size=feature_size_new+feature_size_diff
            dict_var[feature_id]=[feature_type,feature_size,0,0,0]
        
        var_type=var[8]
        if var_type=="insertion":
            dict_var[feature_id][2]+=1
        elif var_type=="deletion":
            dict_var[feature_id][3]+=1
        elif var_type=="substitution":
            dict_var[feature_id][4]+=1

    # calculate the rates. 
    # total exon/... length + total exon/... subs/del/ins
    gene_info=[0,0,0,0] # gene_total_length,gene_total_ins,gene_total_del,gene_total_subs
    mrna_info=[0,0,0,0]
    cds_info=[0,0,0,0]
    utr3_info=[0,0,0,0]
    utr5_info=[0,0,0,0]
    exon_info=[0,0,0,0]
    intron_info=[0,0,0,0]

    for feature in dict_var:
        feature_info=dict_var[feature] # feature_id -> [type,length,ins_count,del_count_subs_count]
        feature_type=feature_info[0]
        match feature_type:
            case "gene":
                gene_info[0]+=feature_info[1]
                gene_info[1]+=feature_info[2]
                gene_info[2]+=feature_info[3]
                gene_info[3]+=feature_info[4]
            case "mRNA":
                mrna_info[0]+=feature_info[1]
                mrna_info[1]+=feature_info[2]
                mrna_info[2]+=feature_info[3]
                mrna_info[3]+=feature_info[4]
            case "CDS":
                cds_info[0]+=feature_info[1]
                cds_info[1]+=feature_info[2]
                cds_info[2]+=feature_info[3]
                cds_info[3]+=feature_info[4]
            case "five_prime_UTR":
                utr5_info[0]+=feature_info[1]
                utr5_info[1]+=feature_info[2]
                utr5_info[2]+=feature_info[3]
                utr5_info[3]+=feature_info[4]
            case "three_prime_UTR":
                utr3_info[0]+=feature_info[1]
                utr3_info[1]+=feature_info[2]
                utr3_info[2]+=feature_info[3]
                utr3_info[3]+=feature_info[4]
            case "exon":
                exon_info[0]+=feature_info[1]
                exon_info[1]+=feature_info[2]
                exon_info[2]+=feature_info[3]
                exon_info[3]+=feature_info[4]
            case "intron":
                intron_info[0]+=feature_info[1]
                intron_info[1]+=feature_info[2]
                intron_info[2]+=feature_info[3]
                intron_info[3]+=feature_info[4]
    
    
    # exon_subs/exon_length
    # print all.
    print(len(dict_var))
    print("gene",gene_info[1]/gene_info[0],gene_info[2]/gene_info[0],gene_info[3]/gene_info[0])
    print("mrna",mrna_info[1]/mrna_info[0],mrna_info[2]/mrna_info[0],mrna_info[3]/mrna_info[0])
    print("cds",cds_info[1]/cds_info[0],cds_info[2]/cds_info[0],cds_info[3]/cds_info[0])
    print("5'utr",utr5_info[1]/utr5_info[0],utr5_info[2]/utr5_info[0],utr5_info[3]/utr5_info[0])
    print("3'utr",utr3_info[1]/utr3_info[0],utr3_info[2]/utr3_info[0],utr3_info[3]/utr3_info[0])
    print("exon",exon_info[1]/exon_info[0],exon_info[2]/exon_info[0],exon_info[3]/exon_info[0])
    print("intron",intron_info[1]/intron_info[0],intron_info[2]/intron_info[0],intron_info[3]/intron_info[0])


test_cecile=False
if test_cecile:
    print("")
    seg_cent={}
    with open('seg_centromeres_irgsp','r') as seg_centromere:
        line=seg_centromere.readline()
        while line:
            line=line.split()
            seg_id=line[3][1:]
            seg_cent[seg_id]=line[3][0]
            line=seg_centromere.readline()

    seg_common=[]
    with open('full_azucena','r') as seg_azu:
        line=seg_azu.readline()
        while line:
            line=line.split()
            seg_id=line[3][1:]
            if seg_id in seg_cent:
                seg_common.append(seg_id)
            line=seg_azu.readline()
    print(len(seg_common))

    
#import subprocess
#output =  subprocess.Popen("wc -l seg_coord/walks.txt", shell=True, stdout=subprocess.PIPE).stdout.read().decode()
#print(output.split()[0])

